__copyright__ = "Copyright (c) 2007-2014 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import app.preprocessor
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Copy TeamForge Home files"

    def createRuntime(self):
        distributionDir = self.cfg['DISTRIBUTION_DIR']
        sourceforgeHome = self.cfg['SOURCEFORGE_HOME']
        app.util.runSystem("mkdir -p %s " % sourceforgeHome, self.log)
        app.util.runSystem("cp -rp %s/sourceforge_home/* %s " %
             (distributionDir, sourceforgeHome), self.log)

        for arch in ("i386", "x86_64"):
            srcFile = os.path.join(sourceforgeHome, 'bin', 'Linux', 'unixutils.%s' %arch)
            if os.path.exists(srcFile):
                 if not self.cfg['PLATFORM'].startswith(arch):
                     cmdStr = "rm %s" %srcFile
                 else:
                     destFile = os.path.join(sourceforgeHome, 'bin', 'Linux', 'unixutils')
                     cmdStr = "mv %s %s" % (srcFile, destFile)
                 app.util.runSystem(cmdStr, self.log)
