__author__ = 'Kamesh Jayachandran <kamesh@collab.net>'
__copyright__ = "Copyright (c) 2012 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.batch
import os


class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Copy CTFAuthorizer"

    def createRuntime(self):
        srcDir = os.path.join(self.cfg['DISTRIBUTION_DIR'], "mod_authnz_ctf")
        platformString = self.cfg['PLATFORM']
        srcFile = os.path.join(srcDir, "ctfauthorizer-%s.so" %platformString)
        destDir = os.path.join(self.cfg['RUNTIME_DIR'], "sourceforge_home", "integration")
        app.util.runSystem("mkdir -p %s " %destDir, self.log)
        destFile = os.path.join(destDir, 'ctfauthorizer.so')
        cmdStr = "cp %s %s" % (srcFile, destFile)
        app.util.runSystem(cmdStr, self.log)
        app.util.runSystem("chmod 755 %s" %destFile, self.log)
