#!/usr/bin/env python2
#
#
#
#
# The above four blank lines brought to you courtesy of the
# CEE wrapper trickery.
# -*- Python -*-

# Used to ensure we use a snap/restore version matching the repo

import os
import os.path
import sys
import pwd

import app.util
import app.vc

me = os.path.basename(sys.argv[0])

def main():
    """Creates the svn repository.
       If default fs_type is bdb, creates the
       bdb repository with DATA, BDB_DATA, BDB_LOG in three different
       directories, otherwise it is straight forward repository creation."""

    if len(sys.argv) > 1:
        repo_name = sys.argv[1]
    else:
        print >>sys.stderr, "Usage: '%s <repository_name>'" % me
        sys.exit(1)

    cfg = app.util.getRuntimeConfiguration()
    cmd = "%s create --fs-type %s %s --config-dir '/non-existing-dir'" % \
                      (cfg.get("SVNADMIN_BINARY"),
                       cfg.get("SUBVERSION_FSTYPE"), repo_name)
    (stdout_lines, stderr_lines) = app.vc.run_cmd(cmd)

    if stderr_lines:
       if (cfg.get("SUBVERSION_FSTYPE") == 'bdb'):
          ignoreBDBWarning = 'warning: The "bdb" repository back-end is deprecated'
          try:
              ''.join(stderr_lines).index('%s'%(ignoreBDBWarning))
              sys.exit(0)
          except Exception, e:
              pass
       print >>sys.stderr, "Repo creation failed %s" % str(stderr_lines)
       sys.exit(1)

if __name__ == "__main__":
    os.environ['HOME'] = pwd.getpwuid(os.getuid())[5]
    main()

