#!/usr/bin/env python2
#
#
#
#
# The above four blank lines brought to you courtesy of the
# CEE wrapper trickery.
# -*- Python -*-

# Used to ensure we use a snap/restore version matching the repo

import os
import sys
import pwd
import shutil
from time import strftime

import app.util

me = os.path.basename(sys.argv[0])

def main():
    """Delete the bdb based svn repository after archiving.
       If default fs_type is bdb delete the bdb repository DATA, BDB_DATA,
       BDB_LOG in three different directories."""

    if len(sys.argv) > 1:
        repo_name = sys.argv[1]
    else:
        print >>sys.stderr, "Usage: '%s <repository_name>'" % me
        sys.exit(1)

    cmd_three_dir_repo = None
    fs_type_str = "bdb"
    data_dir_token = "set_data_dir"

    cfg = app.util.getRuntimeConfiguration()

    # Check for the branding repo also
    if os.path.exists(os.path.join(\
        cfg.get('SUBVERSION_REPOSITORY_BASE'), repo_name)):
        repos_home = os.path.join(cfg.get('SUBVERSION_REPOSITORY_BASE'),\
                                  repo_name)
    else:
        repos_home = os.path.join(cfg.get('SUBVERSION_BRANDING_REPOSITORY_BASE'),\
                                  repo_name)

    timestamp = strftime("%Y%m%d_%H%M%S")
    archivedir = cfg.get("SCM_REPOSITORY_ARCHIVE")

    # Check whether the repo has a three directory structure.
    fs_type_file = os.path.join(repos_home, "db", "fs-type")
    DB_CONFIG_file = os.path.join(repos_home, "db", "DB_CONFIG")

    if fs_type_str in file(fs_type_file).read() and \
           data_dir_token in file(DB_CONFIG_file).read():
        bdb_datafile_dir = os.path.join(cfg.get("BDB_DATAFILE_DIR"), repo_name)
        bdb_logfile_dir = os.path.join(cfg.get("BDB_LOGFILE_DIR"), repo_name)
        bdb_envfile_dir = os.path.join(cfg.get("BDB_ENVFILE_DIR"), repo_name)

        # Archive the bdb data, log file and env data directories.
        darchivefname = repo_name + "-bdbdata-" + timestamp + \
                        ".tar.gz"
        larchivefname = repo_name + "-bdblog-" + timestamp + \
                        ".tar.gz"
        earchivefname = repo_name + "-bdbenv-" + timestamp + \
                        ".tar.gz"
        cmd_data = "tar -zcf " + os.path.join(archivedir, darchivefname) + \
                   " " + bdb_datafile_dir
        cmd_log = "tar -zcf " + os.path.join(archivedir, larchivefname) + \
                  " " + bdb_logfile_dir
        cmd_env = "tar -zcf " + os.path.join(archivedir, earchivefname) + \
                  " " + bdb_envfile_dir
        os.system(cmd_data)
        os.system(cmd_log)
        os.system(cmd_env)

        # Remove the bdb data and log file directories.
        shutil.rmtree(bdb_datafile_dir)
        shutil.rmtree(bdb_logfile_dir)
        shutil.rmtree(bdb_envfile_dir)

    # Archive the repository.
    rarchivefname = repo_name + "-" + timestamp + ".tar.gz"
    cmd_repo = "tar -zcf " + os.path.join(archivedir, rarchivefname) + \
              " " + repos_home
    os.system(cmd_repo)

    # Remove the repository.
    shutil.rmtree(repos_home)

if __name__ == "__main__":
    os.environ['HOME'] = pwd.getpwuid(os.getuid())[5]
    main()
