﻿import os
import app.servicecontrol
import app.defaults
import app.health

class ServiceController(app.servicecontrol.SimpleDaemonController):
    def getPidFile(self):
        return os.path.join(app.defaults.DEFAULT_RUN_DIR, "integration.pid")

    def __getInitScript(self):
        return os.path.join(app.defaults.DEFAULT_SERVICE_DIR, "integration", "bin", "catalina.sh")

    def getCommand(self):
        return "%s run" % self.__getInitScript()

    def stopDaemonAsync(self):
        return os.system("%s stop < /dev/null >> %s 2>&1 &" % (
            self.__getInitScript(),
            self.getServiceLogPath())) == 0

    def isHealthy(self):
        #
        # We directly invoke the Tomcat endpoint (not via Apache). This is okay
        # as Apache has its own health check. Also, it avoids trouble with self-
        # signed SSL certificates.
        #
        jbossHttpEndpoint = self.getService().getProvidedEndpoint("http-soap")

        url = "http://%s:%d/integration/health?verbose=true&thorough=false" % \
            (jbossHttpEndpoint.getHost(), jbossHttpEndpoint.getPort())

        return app.health.HealthCheck("Integration", url, self.logger).invoke()
