import os
import app.servicecontrol
import app.defaults

# Set to True for detailed, per-path indexing log output; set to False
# for summary and warning/error information only.
VERBOSE_OUTPUT_MODE = False

class ServiceController(app.servicecontrol.SimpleDaemonController):
    def getCommand(self):
        cmd = os.path.join(os.path.dirname(os.path.abspath(__file__)),
                           '..', 'bin', 'svn-index-repositories')
        return "%s%s >> %s 2>&1" % (cmd,
                                    VERBOSE_OUTPUT_MODE and ' --verbose' or '',
                                    self.getServiceLogPath())

    def isDemandStart(self):
        # When the service starts, it does its indexing and then it terminates. To do another
        # round of indexing, it needs to be started again.
        return True
