__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

import re
from app.scripts import BaseConfigScript
import service.util
import service.constants
import os

class ConfigScript(BaseConfigScript):

    def __memcache_configSnippet(self):
        if self.cfg.has_key('ENABLE_CACHING_WITH_MEMCACHED') and \
           self.cfg['ENABLE_CACHING_WITH_MEMCACHED'].lower() == 'true':

           if self.cfg.has_key('MEMCACHED_SERVER_HOST'):
              if self.cfg['MEMCACHED_SERVER_HOST'] != "":
                 memcachedHost = self.cfg['MEMCACHED_SERVER_HOST']
              else:
                 memcachedHost = "localhost"

           if self.cfg.has_key('MEMCACHED_SERVER_PORT'):
              if self.cfg['MEMCACHED_SERVER_PORT'] != "":
                 memcachedPort = self.cfg['MEMCACHED_SERVER_PORT']
              else:
                 memcachedPort = "11211"

           if self.cfg.has_key('MEMCACHED_SERVER_TTL'):
              if self.cfg['MEMCACHED_SERVER_TTL'] != "":
                 memcachedTTL = self.cfg['MEMCACHED_SERVER_TTL']
              else:
                 memcachedTTL = "60"
           return """AuthnzCTFMemcacheServer \"%s:%s\"
   AuthnzCTFMemcacheTTL \"%s\"
                  """ %(memcachedHost, memcachedPort, memcachedTTL)

        else:
           return ""

    def configSnippet(self):
        # For Subversion's Apache authn/authz cache, we enable/disable it based
        # on test support being enabled or not.  In production, there is no
        # TEST_SUPPORT_ENABLED key in the site options so we have to handle this
        # case specially. (artf74490)
        disableSubversionCache = 'false'

        if self.cfg.has_key('TEST_SUPPORT_ENABLED'):
            disableSubversionCache = self.cfg['TEST_SUPPORT_ENABLED'].lower()

        memcachedDirectives = self.__memcache_configSnippet()

        return """

<Location %s>
   DAV svn
   SVNParentPath %s
   AuthnzCTFPropertiesFile "/opt/collabnet/teamforge/runtime/conf/integration.properties"
   AuthType Basic
   AuthName "Authorization Realm"
   Require valid-user
   AuthBasicAuthoritative Off
   AuthUserFile /dev/null
   SVNPathAuthz short_circuit
   SVNAllowBulkUpdates prefer

   %s

   # Allows these operations to be disallowed higher up,
   # then enabled here for this Location
   <Limit COPY DELETE GET OPTIONS PROPFIND PROPPATCH PUT MKACTIVITY CHECKOUT MERGE REPORT>
      Order allow,deny
      Allow from all
   </Limit>
</Location>
""" % (self.cfg['SUBVERSION_URI'],
       self.cfg['SUBVERSION_REPOSITORY_BASE'],
       memcachedDirectives)
